// Copyright 2016 CERN and GSI
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
#ifdef MODBUS_SUPPORT_ENABLED
#ifndef _MB_CONNECTION_H_
#define _MB_CONNECTION_H_

#include <silecs-communication/interface/communication/SilecsConnection.h>
#include <modbus.h>

namespace Silecs
{
	class PLC;

	/*!
	 * \class MBConnection
	 * \brief Plc-communication object for specific Modbus protocol
	 */
	class MBConnection : public Connection
	{

	public:
		MBConnection(PLC* thePLC);
 		virtual ~MBConnection();

 		int readData(PLC* thePLC, unsigned long address, unsigned long offset, unsigned long size, unsigned char* pBuffer);
 		int writeData(PLC* thePLC, unsigned long address, unsigned long offset, unsigned long size, unsigned char* pBuffer);

	private:
        modbus_t* readCtx_;
        modbus_t* writeCtx_;
		bool open(PLC* thePLC);
		bool close(PLC* thePLC);

	};

} // namespace

#endif // _MB_CONNECTION_H_

#endif //MODBUS_SUPPORT_ENABLED
